
\chapter{Modules Configuration}

The entire configuration system is meant to be dynamic. That means that you can change the configuration when Somewhere is running.

You can, for example, change the name of the peer, or load a new module. The configuration is split into several parts that correspond to each module. If a module is present without its related configuration, it will be configured using a default configuration. If a configuration related to an non-loaded module is present, it is simply ignored until the module is loaded.

The main way of configuring \emph{Somewhere2} is throw one (or several) xml configuration files (which, actually, can be broken into several files, the sum of the infos of each file becoming a single configuration), where the parent balizes correspond to a module configuration. The module balizes must always be inside the main \emph{<somewhere>} balize.


\section{How to load a config file using the command line ?}
You can use the following command to launch \emph{Somewhere2} with one
XML configuration files :
\begin{lstlisting}[language=sh]
	java -jar Somewhere.jar --importConfigurationFile config.xml
\end{lstlisting}
(where \verb!config.xml! is the name of your configuration file.
You can also import several configuration files:
\begin{lstlisting}[language=sh]
	java -jar Somewhere.jar --importConfigurationFile config1.xml config2.xml config3.xml
\end{lstlisting}
When several configuration files are imported, and several configuration keys
are shared amongst these configuration files, the information of the last file
imported is prevalent.


\section{Base}
The base configuration contains just a indication of where will be the main log file. \\
It can be configured in an xml file like this :
\begin{lstlisting}[language=xml]
<somewhere>
	<base>
		<logFile>somewhere.log</logFile>
	</base>
</somewhere>
\end{lstlisting}
This configuration file saves the \emph{Somewhere2} log file into the \emph{somewhere.log} file on the same folder where the main jar is being executed.\\
It is also the default configuration (in case no \verb!base! balise is found).

\subsection{XSD XML Schema}
Here is the XSD file used for configuring this module :
\begin{lstlisting}[language=xml]
<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema">

	<xsd:element name="somewhere">
		<xsd:complexType>

			<xsd:all>
				<xsd:element name="base" type="base" />
			</xsd:all>

		</xsd:complexType>
	</xsd:element>

	<xsd:complexType name="base">
		<xsd:all>
			<xsd:element name="logFile" type="xsd:string"/>
		</xsd:all>
	</xsd:complexType>

</xsd:schema>  
\end{lstlisting}

\section{Communication}
This module has no configuration for the moment.


\section{JXTA}
The {\bf JXTA} module can be configured like this :
\begin{lstlisting}[language=xml]
<somewhere>
	<jxta>
	    <localPeer>
	        <peerName>localhost</peerName>
	        <peerGroupName>somewherePeerGroup</peerGroupName>
	        <peerType>Edge</peerType>
	        <autoRdvEnabled>true</autoRdvEnabled>
	        <cacheFolder>jxtaCache</cacheFolder>
	        <cacheReUse>false</cacheReUse>
	    </localPeer>
    	<seeds>
	        <rdvPeers/>
	        <relayPeers/>
    	</seeds>
	    <network>
	        <port>6000</port>
	        <enabled>true</enabled>
	        <IncomingEnabled>true</IncomingEnabled>
	        <OutgoingEnabled>true</OutgoingEnabled>
	        <cachedOutputPipe>true</cachedOutputPipe>
	    </network>
	    <service>
	        <version>42</version>
	        <creator>Unknown</creator>
	        <URL>Unknown</URL>
	        <inpipePipeID>0</inpipePipeID>
	        <moduleClassID>0</moduleClassID>
	        <advExpirationTime>30</advExpirationTime>
	        <advLifeTime>30</advLifeTime>
	    </service>
	    <message>
	        <pipeResolveTimeout>30</pipeResolveTimeout>
	        <numberOfRetriesForDiscovery>3</numberOfRetriesForDiscovery>
	        <gapBetweenTwoDiscoveryRequests>10</gapBetweenTwoDiscoveryRequests>
	        <timeoutForAMessage>30</timeoutForAMessage>
	    </message>
	</jxta>
</somewhere>
\end{lstlisting}
This configuration is the default configuration for the {\bf JXTA} module  (in case no \verb!jxta! balise is found).

\subsection{XSD XML Schema}
Here is the XSD file used for configuring this module :
\begin{lstlisting}[language=xml]
<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema">

	<xsd:element name="somewhere">
		<xsd:complexType>

			<xsd:all>
				<xsd:element name="jxta" type="jxta" />
			</xsd:all>

		</xsd:complexType>
	</xsd:element>

	<xsd:complexType name="jxta">

		<xsd:all>
			<xsd:element name="localPeer" type="localPeer" minOccurs="0"/>
			<xsd:element name="seeds" type="seeds" minOccurs="0"/>
			<xsd:element name="network" type="network" minOccurs="0"/>
			<xsd:element name="service" type="service" minOccurs="0"/>
			<xsd:element name="message" type="message" minOccurs="0"/>
		</xsd:all>

	</xsd:complexType>


	<xsd:complexType name="localPeer">
		<xsd:all>
			<xsd:element name="peerType" minOccurs="0">
				<xsd:simpleType>
					<xsd:restriction base="xsd:string">
						<xsd:enumeration value="Edge"/>
      					<xsd:enumeration value="Relay"/>
      					<xsd:enumeration value="Rdv"/>
					</xsd:restriction>
				</xsd:simpleType>
			</xsd:element>
			<xsd:element name="autoRdvEnabled" type="xsd:boolean" minOccurs="0"/>
			<xsd:element name="cacheFolder" type="xsd:string" minOccurs="0"/>
			<xsd:element name="cacheReUse" type="xsd:string" minOccurs="0"/>
		</xsd:all>
	</xsd:complexType>

	<xsd:complexType name="seeds">
		<xsd:all>
			<xsd:element name="rdvPeers" type="rdvPeers" minOccurs="0"/>
			<xsd:element name="relayPeers" type="relayPeers" minOccurs="0"/>
		</xsd:all>
	</xsd:complexType>

	<xsd:complexType name="network">
		<xsd:all>
			<xsd:element name="port" type="xsd:integer" minOccurs="0"/>
			<xsd:element name="Enabled" type="xsd:boolean" minOccurs="0"/>
			<xsd:element name="IncomingEnabled" type="xsd:boolean" minOccurs="0"/>
			<xsd:element name="OutgoingEnabled" type="xsd:boolean" minOccurs="0"/>
			<xsd:element name="cachedOutputPipe" type="xsd:boolean" minOccurs="0"/>
		</xsd:all>
	</xsd:complexType>

	<xsd:complexType name="service">
		<xsd:all>
			<xsd:element name="version" type="xsd:integer" minOccurs="0"/>
			<xsd:element name="creator" type="xsd:string" minOccurs="0"/>
			<xsd:element name="URL" type="xsd:anyURI" minOccurs="0"/>
			<xsd:element name="inpipePipeID" type="xsd:integer" minOccurs="0"/>
			<xsd:element name="moduleClassID" type="xsd:integer" minOccurs="0"/>
			<xsd:element name="advExpirationTime" type="xsd:integer" minOccurs="0"/>
			<xsd:element name="advLifeTime" type="xsd:integer" minOccurs="0"/>
		</xsd:all>
	</xsd:complexType>

	<xsd:complexType name="message">
		<xsd:all>
			<xsd:element name="pipeResolveTimeout" type="xsd:integer" minOccurs="0"/>
			<xsd:element name="fetchAdvertisementTimeout" type="xsd:integer" minOccurs="0"/>
			<xsd:element name="numberOfRetriesForDiscovery" type="xsd:integer" minOccurs="0"/>
			<xsd:element name="gapBetweenTwoDiscoveryRequests" type="xsd:integer" minOccurs="0"/>
			<xsd:element name="timeoutForAMessage" type="xsd:integer" minOccurs="0"/>
			<xsd:element name="rendezvousConnectionTimeout" type="xsd:integer" minOccurs="0"/>
			<xsd:element name="numberOfRetriesForRendezvousConnection"
				type="xsd:integer" minOccurs="0"/>
		</xsd:all>
	</xsd:complexType>


	<xsd:complexType name="rdvPeers">
		<xsd:sequence>
			<xsd:element name="peer" type="peer" minOccurs="0"
				maxOccurs="unbounded" />
		</xsd:sequence>
	</xsd:complexType>

	<xsd:complexType name="relayPeers">
		<xsd:sequence>
			<xsd:element name="peer" type="peer" minOccurs="0"
				maxOccurs="unbounded" />
		</xsd:sequence>
	</xsd:complexType>


	<xsd:complexType name="peer">
		<xsd:simpleContent>
			<xsd:extension base="xsd:string">
			</xsd:extension>
		</xsd:simpleContent>
	</xsd:complexType>

</xsd:schema>  

\end{lstlisting}


Here is a description of what each configuration key do :
\begin{description}
	\item[localPeer]
		Here is gathered base informations about the local peer.
		\begin{description}
			\item[peerName] The name of the local peer. It defaults on the
				local host name of the machine
			\item[peerGroupName] The name of the peer group this peer is in.
			\item[peerType] The type of the peer (cf part on the JXTA network).\\ % TODO : add ref
				It defaults on the Edge type of peer. Here are the possible peer types :
				\begin{description}
					\item[Edge] Edge peer
					\item[Rdv] Rendez-vous peer
					\item[Relay] Relay peer
				\end{description}
			\item[autoRdvEnabled] Set the node to switch to Rendez-vous peer if it can't connect
				to any Rendez-vous peers.
			\item[cacheFolder] Path of a folder used by JXTA for caching
			\item[cacheReUse] Whether or not the cached information must be re-used when the peer is
				restarted.
		\end{description}

	\item[seeds]
		It contains the list of Relay and Rendez-vous peers used by JXTA.
		%TODO : Add details

	\item[network]
		It contains informations about how to communicate with the peer group, 
		for Rendezv-vous peers.
		\begin{description}
			\item[port] The port to use for Rendez-vous
			\item[enabled] If Rendez-vous enabled
			\item[IncomingEnabled] If incoming pipes are enabled
			\item[OutgoingEnabled] If outgoing pipes are enabled
			\item[cachedOutputPipe] TODO % TODO
		\end{description}

	\item[service]
		It contains informations about the JXTA service advertised to the peer group.
		%TODO : Add details
		\begin{description}
			\item[version] Version of the service
			\item[creator] Creator of the service
			\item[URL] URL associated with the service
			\item[inpipePipeID] TODO %TODO
			\item[moduleClassID] TODO %TODO
			\item[advExpirationTime] TODO %TODO
			\item[advLifeTime] TODO %TODO
		\end{description}

	\item[message]
		It contains informations about how to handle the sending and reception of
		messages.
		\begin{description}
			\item[pipeResolveTimeout] Timeout in milliseconds for creating
				outgoing pipe
			\item[numberOfRetriesForDiscovery] Total retries number for discovery
			\item[gapBetweenTwoDiscoveryRequests] The gap in milliseconds between two
				successive discovery requests
			\item[timeoutForAMessage] Timeout in milliseconds for sending a message
		\end{description}
		% TODO : Add details
\end{description}

You can find more information on \url{https://jxta.dev.java.net/}.


